#version 150

#moj_import <fog.glsl>
#moj_import <color.glsl>

uniform vec4 ColorModulator;
uniform float GameTime;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;
uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform vec2 ScreenSize;

in float vertexDistance;

out vec4 fragColor;

void main() {
    float time = GameTime * 1000.0;
    float bright = -mod(GameTime * 10, 1.0);
    float vert = (gl_FragCoord.y) / ScreenSize.y;
    vec3 color = ColorModulator.rgb;
    color = rgb2hsv(color);
    color.x = mod(time - 120 * vert, 360.0) / 360;
    color.y = 1.0;
    color.z = 0.1 * vert + 0.05;
    if(mod((vert + 0.2) * (vert + 0.2) * (vert + 0.2) + bright, 32.0 / ScreenSize.y) < 4.0 / ScreenSize.y){
        color.y -= 0.05 * (1.0 - vert);
        color.z += 0.05 * (1.0 - vert);
    }
    color = hsv2rgb(color);
    fragColor = vec4(color, 1.0);
}
